<?php
/**
 * @version    CVS: 1.7.4
 * @package    com_yoursites
 * @author     Geraint Edwards <yoursites@gwesystems.com>
 * @copyright  2016-2020 GWE Systems Ltd
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('JPATH_BASE') or die;

use Joomla\CMS\Access\Access;
use Joomla\CMS\Version;
use Joomla\CMS\Router\Route;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Language\Text;

JLoader::register('JEventsHelper', JPATH_ADMINISTRATOR . "/components/com_jevents/helpers/jevents.php");

class GslLocationsMenuHelper
{

	static public function getLeftIconSubLinks($leftmenutrigger)
	{


		$compparams = ComponentHelper::getParams("com_jevlocations");
		$usecats = $compparams->get("usecats", 0);

		$iconLinks = array();

		$iconLink                 = new stdClass();
		$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
		$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
		$iconLink->active         = false;
		$iconLink->link           = Route::_("index.php?option=com_jevlocations&task=locations.overview");
		$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
		$iconLink->icon           = "location";
		$iconLink->label           = Text::_('COM_JEVLOCATIONS');
		$iconLink->tooltip         = $leftmenutrigger !== 2 ? "" : Text::_("COM_JEVLOCATIONS");;
		$iconLink->tooltip_detail = "";
		$iconLinks[]              = $iconLink;

		if ($usecats)
		{
			$iconLink                 = new stdClass();
			$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
			$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
			$iconLink->active         = false;
			$iconLink->link           = Route::_("index.php?option=com_jevlocations&task=categories.list");
			$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
			$iconLink->icon           = "world";
			$iconLink->label           = Text::_('COM_JEVLOCATIONS_COUNTRY_STATE_CITY');
			$iconLink->tooltip         = $leftmenutrigger !== 2 ? "" : Text::_("COM_JEVLOCATIONS_COUNTRY_STATE_CITY");;
			$iconLink->tooltip_detail = "";
			$iconLinks[]              = $iconLink;
		}

		$iconLink                 = new stdClass();
		$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
		$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
		$iconLink->active         = false;
		$iconLink->link           = Route::_("index.php?option=com_categories&extension=com_jevlocations");
		$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
		$iconLink->icon           = "thumbnails";
		$iconLink->label           = Text::_('COM_JEVLOCATIONS_LOCATION_CATEGORIES');
		$iconLink->tooltip         = $leftmenutrigger !== 2 ? "" : Text::_("COM_JEVLOCATIONS_LOCATION_CATEGORIES");;
		$iconLink->tooltip_detail = "";
		$iconLinks[]              = $iconLink;

		Factory::getLanguage()->load("com_jevents", JPATH_ADMINISTRATOR);
		$iconLink                 = new stdClass();
		$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
		$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
		$iconLink->active         = false;
		$iconLink->link           = Route::_("index.php?option=com_jevents&task=defaults.list&filter_layout_type=jevlocations");
		$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
		$iconLink->icon           = "file-edit";
		$iconLink->label           = Text::_('JEV_LAYOUT_DEFAULTS');
		$iconLink->tooltip         = $leftmenutrigger !== 2 ? "" : Text::_("JEV_LAYOUT_DEFAULTS");;
		$iconLink->tooltip_detail = "";
		$iconLinks[]              = $iconLink;

		$iconLink                 = new stdClass();
		$iconLink->class          = "gsl-button gsl-small gsl-button-secondary gsl-padding-remove gsl-text-left ";
		$iconLink->iconclass      = "gsl-margin-small-right gsl-display-inline-block";
		$iconLink->active         = false;
		$iconLink->link           = Route::_("index.php?option=com_jevlocations&task=params.edit");
		$iconLink->onclick        = "(function(e) { document.location='" . $iconLink->link . " ';return false;})(event);";
		$iconLink->icon           = "settings";
		$iconLink->label          = Text::_('COM_JEVLOCATIONS_CONFIG');
		$iconLink->tooltip        = $leftmenutrigger !== 2 ? "" : Text::_('COM_JEVLOCATIONS_CONFIG_TOOLTIP', true);
		$iconLink->tooltip_detail = "";
		$iconLinks[]              = $iconLink;

		return $iconLinks;
	}

}
