<?php

// No direct access
defined('_JEXEC') or die;

use Joomla\Registry\Registry;
use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Object\CMSObject;
use Joomla\CMS\Factory;

/**
 * JEvents component helper.
 *
 * @package		Jevents
 * @since		1.6
 */
class JevlocationsHelper
{
	public static $extension = 'com_jevlocations';

	public static function validateSection($context, $form = null)
	{
        $vName      = Factory::getApplication()->input->getCmd('view', 'categories');

        if ($context == "categories" && Factory::getApplication()->input->get('view') == "category"  && Factory::getApplication()->input->get('layout') == "edit")
		{
			if (!defined("GSLMSIE10"))
			{
				if (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], "MSIE") !== false || strpos($_SERVER['HTTP_USER_AGENT'], "Internet Explorer") !== false))
				{
					define ("GSLMSIE10" , 1);
				}
				else
				{
					define ("GSLMSIE10" , 0);
				}
			}

            if (!GSLMSIE10)
            {
                $app = Factory::getApplication();
                $component = $app->bootComponent('com_categories');
                $dispatcher = $component->getDispatcher($app);
                $controller = $dispatcher->getController('display', 'Administrator', array('option' => 'com_categories'));

                $view = $controller->getView($vName, 'html', 'Administrator');
                $view->addTemplatePath(JPATH_ADMINISTRATOR . "/components/com_jevents/views/com_categories/$vName/tmpl/");

            }
		}
		return false;
	}

	/**
	 * Configure the Linkbar.
	 *
	 * @param	string	The name of the active view.
	 */
	public static function addSubmenu($vName)
	{
		if (!defined("GSLMSIE10"))
		{
			if (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], "MSIE") !== false || strpos($_SERVER['HTTP_USER_AGENT'], "Internet Explorer") !== false))
			{
				define ("GSLMSIE10" , 1);
			}
			else
			{
				define ("GSLMSIE10" , 0);
			}
		}

		$input = Factory::getApplication()->input;

		$option = $input->getCmd("option", "com_categories");

		if ($option !== 'com_categories' && !GSLMSIE10)
		{
			return;
		}
		if ($option == 'com_categories' )
		{
			if (!GSLMSIE10)
			{
				$controller = BaseController::getInstance("Categories");
				$view       = $controller->getView("categories", 'html', 'categoriesView');

				$view->addTemplatePath(JPATH_ADMINISTRATOR . "/components/com_jevlocations/views/com_categories/categories/tmpl/");
			}

			$doc = Factory::getDocument();

			$style = '#toolbar-options {'
				. 'display:none;'
				. '}';


			// Category styling
			$style .= <<<STYLE
#categoryList td.center a {
   /* border:none;*/
}
STYLE;
			Factory::getDbo()->setQuery("SELECT * FROM #__categories WHERE extension='com_jevlocations'");
			$categories = Factory::getDbo()->loadObjectList('id');
			foreach ($categories as $cat)
			{
				$catparams = new Registry($cat->params);
				if ($catparams->get("catcolour"))
				{
					$style .= "tr[item-id='$cat->id'] a {  border-left:solid 3px  " . $catparams->get("catcolour") . ";padding-left:5px;}\n";
				}
			}

			$doc->addStyleDeclaration($style);
		}

		//JSubMenuHelper deprecated in 4.0
		JHtmlSidebar::addEntry(Text::_( 'CONTROL_PANEL' ),'index.php?option=com_jevlocations', false);
		JHtmlSidebar::addEntry(Text::_('MANAGE_LOCATIONS'), 'index.php?option=com_jevlocations&task=locations.overview', false);
		$compparams = ComponentHelper::getParams("com_jevlocations");
		$usecats = $compparams->get("usecats", 0);
		if ($usecats)
		{
			JHtmlSidebar::addEntry(Text::_('COM_JEVLOCATIONS_COUNTRY_STATE_CITY'), "index.php?option=com_jevlocations&task=categories.list", false);
		}
		JHtmlSidebar::addEntry(Text::_('COM_JEVLOCATIONS_CATEGORIES'), 'index.php?option=com_categories&extension=com_jevlocations', true);
		JLoader::register('JEVHelper',JPATH_SITE."/components/com_jevents/libraries/helper.php");
		if (JEVHelper::isAdminUser())
		{
			Factory::getLanguage()->load("com_jevents", JPATH_ADMINISTRATOR);
			JHtmlSidebar::addEntry( Text::_('JEV_LAYOUT_DEFAULTS'), "index.php?option=com_jevents&task=defaults.list&filter_layout_type=jevlocations", false);
		}
		JHtmlSidebar::addEntry( Text::_('COM_JEVLOCATIONS_RETURN_TO_JEVENTS'), "index.php?option=com_jevents&task=cpanel.cpanel", false);


	}

	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @param	int		The category ID.
	 * @param	int		The article ID.
	 *
	 * @return	CMSObject
	 */
	public static function getActions($categoryId = 0, $articleId = 0)
	{
		$user	= Factory::getUser();
		$result	= new CMSObject;

		if (empty($articleId) && empty($categoryId)) {
			$assetName = 'com_jevlocations';
		}
		else if (empty($articleId)) {
			$assetName = 'com_jevlocations.category.'.(int) $categoryId;
		}
		else {
			$assetName = 'com_jevlocations.article.'.(int) $articleId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
}