<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_config
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Form\FormHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

$app = Factory::getApplication();
$template = $app->getTemplate();

// Load the tooltip behavior.
HTMLHelper::_('bootstrap.tooltip');
HTMLHelper::_('behavior.formvalidator');
HTMLHelper::_('behavior.keepalive');
$jversion = new Joomla\CMS\Version;
if (!$jversion->isCompatible('4.0'))
{
	HTMLHelper::_('formbehavior.chosen', '.chzn-custom-value', null, array('disable_search_threshold' => 0));
	HTMLHelper::_('formbehavior.chosen', 'select');
}

// Load JS message titles
Text::script('ERROR');
Text::script('WARNING');
Text::script('NOTICE');
Text::script('MESSAGE');

Factory::getDocument()->addScriptDeclaration(
	'
	Joomla.submitbutton = function(task)
	{
		if (task === "config.cancel.component" || document.formvalidator.isValid(document.getElementById("component-form")))
		{
			jQuery("#permissions-sliders select").attr("disabled", "disabled");
			Joomla.submitform(task, document.getElementById("component-form"));
		}
	};

	// Select first tab
	jQuery(document).ready(function() {
		jQuery("#configTabs a:first").tab("show");
	});'
);
?>
<div class="jevlocations">
<form action="<?php echo Route::_('index.php?option=com_jevlocations'); ?>" id="component-form" method="post" name="adminForm" autocomplete="off" class="form-validate form-horizontal">

        <div class="gsl-grid  gsl-margin-remove-left" id="config">

			<?php if ($this->fieldsets): ?>
                <ul class="gsl-tab gsl-tab-left gsl-margin-right gsl-width-auto gsl-list-divider" id="configTabs" gsl-tab="connect: #configContent">
					<?php foreach ($this->fieldsets as $name => $fieldSet) : ?>
						<?php $dataShowOn = ''; ?>
						<?php if (!empty($fieldSet->showon)) : ?>
							<?php HTMLHelper::_('jquery.framework'); ?>
							<?php HTMLHelper::_('script', 'jui/cms.js', array('version' => 'auto', 'relative' => true)); ?>
							<?php $dataShowOn = ' data-showon=\'' . json_encode(FormHelper::parseShowOnConditions($fieldSet->showon, $this->formControl)) . '\''; ?>
						<?php endif; ?>
						<?php $label = empty($fieldSet->label) ? 'COM_CONFIG_' . $name . '_FIELDSET_LABEL' : $fieldSet->label; ?>
                        <li<?php echo $dataShowOn; ?>><a data-toggle="tab" href="#<?php echo $name; ?>"><?php echo Text::_($label); ?></a></li>
					<?php endforeach; ?>
                </ul><!-- /configTabs -->

        <!-- Tabs themselves //-->
	        <div class=" gsl-margin-remove gsl-card-body gsl-card-default gsl-padding gsl-width-expand">
                <div class="gsl-switcher" id="configContent">
					<?php foreach ($this->fieldsets as $name => $fieldSet) : ?>
                        <div class="gsl-width-1-1" id="<?php echo $name; ?>">
							<?php if (isset($fieldSet->description) && !empty($fieldSet->description)) : ?>
                                <div class="tab-description alert alert-info">
                                    <span class="icon-info" aria-hidden="true"></span> <?php echo Text::_($fieldSet->description); ?>
                                </div>
							<?php endif; ?>
							<?php foreach ($this->form->getFieldset($name) as $field) : ?>
								<?php
								$dataShowOn = '';
								$groupClass = $field->type === 'Spacer' ? ' field-spacer' : '';
								?>
								<?php if ($field->showon) : ?>
									<?php HTMLHelper::_('jquery.framework'); ?>
									<?php HTMLHelper::_('script', 'jui/cms.js', array('version' => 'auto', 'relative' => true)); ?>
									<?php $dataShowOn = ' data-showon=\'' . json_encode(FormHelper::parseShowOnConditions($field->showon, $field->formControl, $field->group)) . '\''; ?>
								<?php endif; ?>
								<?php if ($field->hidden) : ?>
									<?php echo $field->input; ?>
								<?php else : ?>
                                    <div class="gsl-grid <?php echo $groupClass; ?>"<?php echo $dataShowOn; ?>>
										<?php if ($name != 'permissions') : ?>
                                            <div class="gsl-width-1-2">
												<?php echo $field->label; ?>
                                            </div>
										<?php endif; ?>
                                        <div class="<?php if ($name != 'permissions') : ?>gsl-width-1-2<?php endif; ?> ">
											<?php echo $field->input; ?>
                                        </div>
                                    </div>
								<?php endif; ?>
							<?php endforeach; ?>
                        </div>
					<?php endforeach; ?>
                </div><!-- /configContent -->
				</div>
			<?php else: ?>
                <div class="alert alert-info"><span class="icon-info" aria-hidden="true"></span> <?php echo Text::_('COM_CONFIG_COMPONENT_NO_CONFIG_FIELDS_MESSAGE'); ?></div>
			<?php endif; ?>

        </div><!-- /config -->

        <input type="hidden" name="id" value="<?php echo $this->component->id; ?>" />
        <input type="hidden" name="component" value="<?php echo $this->component->option; ?>" />

        <input type="hidden" name="task" value="" />
		<?php echo HTMLHelper::_('form.token'); ?>

</form>
</div>