<?php
/**
 * JEvents Component for Joomla! 3.x
 *
 * @version     $Id: view.html.php 2692 2011-10-04 10:33:39Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2019 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

/**
 * HTML View class for the component
 *
 * @static
 */
class adminparamsViewadminparams extends JEventsAbstractView
{

	function edit()
	{

		$document = Factory::getDocument();
		$document->setTitle(Text::_('COM_JEVLOCATIONS_CONFIGURATION'));

		// Set toolbar items for the page
		JToolbarHelper::title(Text::_('COM_JEVLOCATIONS_CONFIGURATION'), 'jevlocations');

		JToolbarHelper::apply('params.apply');
		JToolbarHelper::save('params.save');
		JToolbarHelper::cancel('cpanel.cpanel');


		$model = $this->getModel();

		HTMLHelper::_('bootstrap.tooltip');

		jimport('joomla.form.form');

		// Add the search path for the admin component config.xml file.
		\Joomla\CMS\Form\Form::addFormPath(JPATH_ADMINISTRATOR . '/components/' . JEV_COM_COMPONENT);

		// Get the form.
		$modelForm = $model->getForm();

		$component = $this->get('Component');
		// Bind the form to the data.
		if ($modelForm && $component->params)
		{
			$modelForm->bind($component->params);
		}

		$this->form      = $modelForm;

		$this->fieldsets   = $modelForm ? $modelForm->getFieldsets() : null;

		$user = Factory::getUser();
		// Don't show permissions fieldset if not authorised.
		if (!$user->authorise('core.admin', $component->option) && isset($this->fieldsets['permissions']))
		{
			unset($this->fieldsets['permissions']);
		}

		$this->formControl = $modelForm ? $modelForm->getFormControl() : null;

		$this->component = $component;


	}

}
