<?php

use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Factory;

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id: edit_com_jevlocations.locations.detail.php 2522 2011-09-01 10:04:51Z geraintedwards $
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
defined('_JEXEC' ) or die('Restricted access');
?>
<h3><?php echo Text::_("COM_JEVLOCATIONS_LAYOUT_INSTRUCTIONS_TITLE", true); ?></h3>
<p><?php echo Text::_("COM_JEVLOCATIONS_LAYOUT_INSTRUCTIONS_DESC"); ?></p>
<dl>
    <dt style="font-style: italic;"><?php echo Text::_("COM_JEVLOCATIONS_LAYOUT_IMAGE_CLASS", true); ?></dt>
    <dd><?php echo Text::_("COM_JEVLOCATIONS_LAYOUT_IMAGE_CLASS_DESC"); ?></dd>
    <dt style="font-style: italic;"><?php echo Text::_("COM_JEVLOCATIONS_LAYOUT_FIELD_CLASS", true); ?></dt>
    <dd><?php echo Text::_("COM_JEVLOCATIONS_LAYOUT_FIELD_CLASS_DESC"); ?></dd>
</dl>

<p><?php echo Text::_("JEV_PLUGIN_INSTRUCTIONS", true); ?></p>
<div><select id="jevdefaults" onchange="defaultsEditorPlugin.insert('value','jevdefaults' )" ></select></div>

<script type="text/javascript">
    document.addEventListener('DOMContentLoaded', function() {
	defaultsEditorPlugin.node('#jevdefaults',"<?php echo Text::_("JEV_PLUGIN_SELECT", true); ?>","");
	// built in group
	var optgroup = "";

<?php
// get list of enabled plugins
$jevplugin  = PluginHelper::getPlugin("jevents", "jevlocations");
$plgName    = !empty($jevplugin->name) ? $jevplugin->name : '';
if (PluginHelper::importPlugin("jevents", $plgName))
{
	$classname = "plgJevents" . ucfirst($plgName);
	if (is_callable(array($classname, "fieldNameArray")))
	{
		$lang = Factory::getLanguage();
		$lang->load("plg_jevents_" . $jevplugin->name, JPATH_ADMINISTRATOR);
		$fieldNameArray = call_user_func(array($classname, "fieldNameArray"),"bloglist");
		if (!isset($fieldNameArray['labels']))
			return;
		?>
					optgroup = defaultsEditorPlugin.optgroup('#jevdefaults' , '<?php echo $fieldNameArray["group"]; ?>');
		<?php
		for ($i = 0; $i < count($fieldNameArray['labels']); $i++)
		{
			?>
							defaultsEditorPlugin.node(optgroup , "<?php echo $fieldNameArray['labels'][$i]; ?>", "<?php echo $fieldNameArray['values'][$i]; ?>");
			<?php
			if (false && strpos($fieldNameArray['values'][$i], "_lbl") === false)
			{
				?>
							defaultsEditorPlugin.node(optgroup , "<?php echo  $fieldNameArray['labels'][$i].' Label'; ?>", "<?php echo str_replace('}}','_lbl}}',$fieldNameArray['values'][$i]); ?>");
				<?php
			}
		}
		?>
		defaultsEditorPlugin.node(optgroup , "<?php echo Text::_('COM_JEVLOCATIONS_UPCOMING_EVENTS', true); ?>", "JEVLOC_UPCOMING");
        try {
            jQuery('#jevdefaults').trigger("chosen:updated");
            jQuery('#jevdefaults').trigger("liszt:updated");
        }
        catch (e)
        {

        }
		<?php
	}
}
?>
    });
</script>
