<?php
/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C)  2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Factory;
?>
<table cellpadding="0" cellspacing="0" border="0">
	<tr>
		<td><?php echo Text::_("JEV_PLUGIN_INSTRUCTIONS", true); ?></td>
		<td><select id="jevdefaults" onchange="defaultsEditorPlugin.insert('value', 'jevdefaults')" ></select></td>
	</tr>
</table>

<script type="text/javascript">
    document.addEventListener('DOMContentLoaded', function() {
	defaultsEditorPlugin.node('#jevdefaults', "<?php echo Text::_("JEV_PLUGIN_SELECT", true); ?>", "");
	// built in group
	var optgroup = "";

<?php
// get list of enabled plugins
$plugins = array();
$jevplugin = PluginHelper::getPlugin("jevents", "jevlocations");
$plugins[] = $jevplugin;
if ($jevplugin = PluginHelper::getPlugin("jevents", "jevjcomments")){
    $plugins[] = $jevplugin;
}
//Load in the FacebookSocial plugin
if ($jevplugin = PluginHelper::getPlugin("jevents", "jevfacebooksocial")){
    $plugins[] = $jevplugin;
}
// Should not do this - these are the custom fields for events!!!
if ($jevplugin = PluginHelper::getPlugin("jevents", "jevcustomfields")){
   // $plugins[] = $jevplugin;
}
foreach ($plugins as $jevplugin)
{
	if (PluginHelper::importPlugin("jevents", $jevplugin->name))
	{
		$classname = "plgJevents" . ucfirst($jevplugin->name);
		if (is_callable(array($classname, "fieldNameArray")))
		{
			$lang = Factory::getLanguage();
			$lang->load("plg_jevents_" . $jevplugin->name, JPATH_ADMINISTRATOR);
			$fieldNameArray = call_user_func(array($classname, "fieldNameArray"));
			if (!isset($fieldNameArray['labels']))
				continue;
			?>
				optgroup = defaultsEditorPlugin.optgroup('#jevdefaults', '<?php echo $fieldNameArray["group"]; ?>');
			<?php
			for ($i = 0; $i < count($fieldNameArray['labels']); $i++)
			{
				?>
					defaultsEditorPlugin.node(optgroup, "<?php echo $fieldNameArray['labels'][$i]; ?>", "<?php echo $fieldNameArray['values'][$i]; ?>");
				<?php
				if (false && strpos($fieldNameArray['values'][$i], "_lbl") === false)
				{
					?>
						defaultsEditorPlugin.node(optgroup, "<?php echo $fieldNameArray['labels'][$i] . ' Label'; ?>", "<?php echo str_replace('}}', '_lbl}}', $fieldNameArray['values'][$i]); ?>");
					<?php
				}
			}
			?>
		    try {
			    jQuery('#jevdefaults').trigger("chosen:updated");
			    jQuery('#jevdefaults').trigger("liszt:updated");
		    }
		    catch (e)
		    {

		    }
		    <?php
		}
	}
}
?>
    });
</script>
