<?php

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;

/**
 * JEvents Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

defined('_JEXEC' ) or die( 'No Direct Access' );

// searches location of event
class jevLocationsearchFilter extends jevFilter
{
	function __construct($tablename, $filterfield, $isstring=true){
		$this->filterType="locsearch";
		$this->filterLabel=Text::_( 'SEARCH_BY_LOCATION' );
		$this->filterNullValue="";
		$lang 		= Factory::getLanguage();
		$lang->load("plg_jevents_jevlocations", JPATH_ADMINISTRATOR);	// RSH 11/2/10 - Make sure language file is loaded			
		parent::__construct($tablename,$filterfield, true);
		
		// Should these be ignored?
		$reg = Factory::getConfig();
		$modparams = $reg->get("jev.modparams",false);
		if ($modparams && $modparams->get("ignorefiltermodule",false)){
			$this->filter_value = $this->filterNullValue;
		}
		
	}

	function _createFilter($prefix=""){
		if (!$this->filterField ) return "";
		if (trim($this->filter_value)==$this->filterNullValue || strlen(trim($this->filter_value))<3) return "";

		$db = Factory::getDBO();
		$text = $db->Quote( '%'.$db->escape( $this->filter_value, true ).'%', false );

		//$filter = "(det.summary LIKE $text OR det.description LIKE $text OR det.extra_info LIKE $text)";

		$compparams = ComponentHelper::getParams("com_jevlocations");
		$usecats = $compparams->get("usecats",0);
		if ($usecats){
			$filter = "(loc.title LIKE $text)";
		}
		else {
			$filter = "(loc.title LIKE $text OR loc.city LIKE $text OR loc.state LIKE $text OR loc.country LIKE $text OR loc.postcode LIKE $text)";
			// if searching custom field values too
			/*
			$filter = "(loc.title LIKE $text OR loc.city LIKE $text OR loc.state LIKE $text OR loc.country LIKE $text OR loc.postcode LIKE $text"
				 . " OR loc.loc_id IN (SELECT target_id FROM #__jev_customfields3 WHERE value LIKE $text ) "
				.")";
			 */
		}
		return $filter;
	}

	function _createJoinFilter($prefix=""){
		$compparams = ComponentHelper::getParams("com_jevlocations");
		$usecats = $compparams->get("usecats",0);
		//if (!$usecats){
			// always need the join!!
			//if (!$this->filterField ) return "";
			//if ($this->filter_value==$this->filterNullValue) return "";
			return " #__jev_locations as loc ON loc.loc_id=det.loc_id";

		//}
		return "";
	}

	function _createfilterHTML(){

		if (!$this->filterField) return "";

		$db = Factory::getDBO();

		$filterList=array();
		$filterList["title"]="<label class='evlocsearch_label' for='".$this->filterType."_fv'>".$this->filterLabel."</label>";
		$filterList["html"] = "<input type='text' name='".$this->filterType."_fv' id='".$this->filterType."_fv' class='evlocsearch'  value='".$this->filter_value."' />";

		$script = "try {JeventsFilters.filters.push({id:'".$this->filterType."_fv',value:''});} catch (e) {}";
		$document = Factory::getDocument();
		$document->addScriptDeclaration($script);
		
		return $filterList;

	}

	public function setSearchKeywords(& $extrajoin ){
		$db = Factory::getDBO();
		if (is_array($extrajoin)){
			foreach ($extrajoin as $join){
				if (strpos($join, "jev_locations as loc")>0){
					$joinedLoc = true;
					break;;
				}
			}
			if (!$joinedLoc){
				$extrajoin[] = " LEFT JOIN #__jev_locations as loc ON loc.loc_id=det.loc_id";
			}
		}
		else {
			$joinedLoc = false;
			if (strpos($extrajoin, "jev_locations as loc")>0){
				$joinedLoc = true;
			}
			if (!$joinedLoc){
				$extrajoin = " LEFT JOIN #__jev_locations as loc ON loc.loc_id=det.loc_id";
			}
		}
		return array("loc.title LIKE (".$db->Quote("%".'###'."%").")");
	}

}