<?php
/**
 * @copyright	Copyright (C) 2008-2011 GWE Systems Ltd. All rights reserved.
 * @license		By negoriation with author via http://www.gwesystems.com
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC' ) or die('Restricted access');

use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Filter\InputFilter;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Factory;


function ProcessJsonRequest(&$requestObject, $returnData)
{

	define("REQUESTOBJECT", serialize($requestObject));
	define("RETURNDATA", serialize($returnData));

	require_once JPATH_BASE . "/" . 'includes' . "/" . 'defines.php';
	require_once JPATH_BASE . "/" . 'includes' . "/" . 'framework.php';

	$requestObject = unserialize(REQUESTOBJECT);
	$returnData = unserialize(RETURNDATA);

	$returnData->titles = array();
	$returnData->exactmatch = false;

	ini_set("display_errors", 0);

	$client = "site";
	if (isset($requestObject->client) && in_array($requestObject->client, array("site", "administrator")))
	{
		$client = $requestObject->client;
	}
	$mainframe =  Factory::getApplication($client);
	$mainframe->initialise();

	$GLOBALS["mainframe"] = $mainframe;

	if (!version_compare(JVERSION, "1.6.0", 'ge')){
		PluginHelper::importPlugin('system');
		$mainframe->triggerEvent('onAfterInitialise');
	}

	jimport("joomla.html.parameter");

	include_once(JPATH_SITE."/components/com_jevents/jevents.defines.php");
	
	// Enforce referrer
	if (true)
	{
		if (!array_key_exists("HTTP_REFERER", $_SERVER))
		{
			throwerror("There was an error");
		}

		$live_site = $_SERVER['HTTP_HOST'];
		$ref_parts = parse_url($_SERVER["HTTP_REFERER"]);

		if (!isset($ref_parts["host"]) || $ref_parts["host"] != $live_site)
		{
			throwerror("There was an error - missing host in referrer");
		}
	}

	$token = Session::getFormToken();
	if (!isset($requestObject->token) || $requestObject->token != $token)
	{
		throwerror("There was an error - bad token.  Please refresh the page and try again.");
	}

	$user = Factory::getUser();
	if ($user->id == 0)
	{
		throwerror("There was an error");
	}

	if ($requestObject->error)
	{
		return "Error";
	}
	if ($requestObject->task == "findLoc" && isset($requestObject->title) && trim($requestObject->title) !== "")
	{
		$returnData->result = "title is " . $requestObject->title;
	}
	else 
	{
		throwerror("There was an error - no valid argument");
	}

	$db = Factory::getDBO();

	$title = InputFilter::getInstance()->clean($requestObject->title, "string");
	$text = $db->Quote('%' . $db->escape($text, true) . '%', false);

	// Remove any dodgy characters from fiel"/"
	// Only allow a to z , 0 to 9, ', " space (\\040), hyphen (\\-), underscore (\\_)
	/*
	  $regex     = '/[^a-zA-Z0-9_\'\"\'\\40\\-\\_]/';
	  $title    = preg_replace($regex, "", $title);
	  $title = substr($title."    ",0,4);
	 */

	if ($requestObject->task == "findLoc" && trim($title) == "" && trim($title) == "")
	{
		throwerror("There was an error - no valid argument");
	}

	if ($requestObject->task == "findLoc" && strlen($title) < 2 && $title != "*")
	{
		$returnData->result = 0;
		return $returnData;
	}

	if($requestObject->task == "findLoc")
	{
		if (ComponentHelper::getParams("com_jevlocations")->get("groupusage", 0)){
			$groups = $user->getAuthorisedGroups();
			$where1 = ' (global = 1 OR created_by=' . $user->id . ' OR groupusage IN ('.implode(",",$groups) .' ) )';
		}
		else {
			$where1 = ' (global = 1 OR created_by=' . $user->id . '  )';
		}

		if ($title != "*")
		{
			$sql = "SELECT loc_id, title, street, postcode, city, country, geolon, geolat, mapicon FROM #__jev_locations WHERE $where1 AND  (title LIKE " . $db->Quote($title . "%") . " OR city LIKE " . $db->Quote($title . "%") . ") order by title, city, postcode, country asc";
		}
		else
		{
			$sql = "SELECT loc_id, title, street, postcode, city, country , geolon, geolat, mapicon FROM #__jev_locations  WHERE $where1 order by title, city, postcode, country asc";
		}
	}

	$db->setQuery($sql);
	$matches = $db->loadObjectList();
	if (count($matches) == 0)
	{
		$returnData->result = 0;
	}
	else
	{
		$returnData->result = count($matches);
		foreach ($matches as $match)
		{
			if (trim(strtolower($match->name)) == trim(strtolower($title)) || trim(strtolower($match->username)) == trim(strtolower($title)))
				$returnData->exactmatch = true;
			$parts = array($match->title, $match->street, $match->city, $match->postcode, $match->country);
			$returnData->titles[] = array("title" => $match->title, "long" => implode(", ", $parts), "loc_id" => $match->loc_id, "geolon" => $match->geolon, "geolat" => $match->geolat, "mapicon" => $match->mapicon);
		}
	}
	
	return $returnData;
}
