var myMap = false;
var myMarker = false;
var disableautopan = false;

function myMapload(edit ) {

	if (typeof edit == 'undefined')
	{
		edit = false;
	}
	if (typeof mapsprovider == "undefined" || mapsprovider == "googlemaps") {
		//myMaploadLeafletGoogle();
		myMaploadGoogle(edit);
	}
	else {
		myMaploadLeafletOsm(edit);
		//myMaploadOsmGoogle();
	}
}

function myMaploadGoogle(edit){

	//We need to be sure there is a map container to put the map in
	var $gmap =  jQuery('#gmap');
	if($gmap.length>0)
	{
		var point =  new google.maps.LatLng(globallat,globallong);

		var myOptions = {
			center: point,
			zoom: globalzoom,
			mapTypeId: google.maps.MapTypeId[maptype]
		};

	
		myMap = new google.maps.Map(document.getElementById("gmap"), myOptions);

		if (maptype == "ROADMAP"){
			mtype="m";
		}
		else if (maptype == "SATELLITE"){
			mtype="k";
		}
		else if (maptype == "TERRAIN"){
			mtype="p";
		}
		else {
			mtype="h";
		}

		if (!markerOptions) {
			//markerOptions = {draggable:true };
			var markerOptions = {
				position:point,
				map:myMap,
				disableAutoPan:disableautopan,
				animation: google.maps.Animation.DROP,
				draggable: ( edit ? true : false),
				icon: urlrootloc + mapicon
			};
		}

		//var point = new GLatLng(globallat,globallong);
		//myMap.setCenter(point, globalzoom );

		myMarker = new google.maps.Marker( markerOptions);
		//myMap.addOverlay(myMarker);
		myMarker.setMap(myMap);


		if (edit)
		{
			google.maps.event.addListener(myMap, 'click',  function(e) {
				if (e.latLng) {
					document.getElementById('geolat').value=e.latLng.lat();
					document.getElementById('geolon').value=e.latLng.lng();
					document.getElementById('geozoom').value=myMap.getZoom();

					myMarker.setPosition(e.latLng);
					myMap.setCenter(e.latLng);
				}
			});

			google.maps.event.addListener(myMarker, "dragend", function(e) {
				if (e.latLng) {
					document.getElementById('geolat').value=e.latLng.lat();
					document.getElementById('geolon').value=e.latLng.lng();
					document.getElementById('geozoom').value=myMap.getZoom();
					myMap.setCenter(e.latLng);
				}
			});

			google.maps.event.addListener(myMap,  "zoom_changed", function() {
				document.getElementById('geozoom').value=myMap.getZoom();
			});

		}
		else {
			google.maps.event.addListener(myMap, "click", function (e) {
				window.open(directionsurl, "map");
			});

			google.maps.event.addListener(myMarker, "click", function (e) {
				window.open(directionsurl, "map");
			});
		}

	}

};

function myMaploadLeafletOsm(edit) {

	if (typeof L == 'undefined' || !document.getElementById("gmap")) return;

	var point = new L.LatLng(globallat, globallong);

	var myOptions = {
		center : point,
		zoom : globalzoom,
		zoomControl : true,
		minZoom: 4,
		maxZoom: 18,
		draggable : false,
	};

	//var myMap = L.map('gmap').setView(point, globalzoom);
	myMap = L.map('gmap', myOptions);

	// create the tile layer with correct attribution
	var osmUrl='https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
	var osmAttrib='Map data © <a href="https://openstreetmap.org">OpenStreetMap</a> contributors';
	var osm = new L.TileLayer(osmUrl, {attribution: osmAttrib});

	L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
		attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors',
	}).addTo(myMap);

	var myIcon = L.icon({
		iconUrl: urlrootloc + mapicon,
		iconSize: [32, 32],
		// The anchor for this image is the base of the flagpole at 0,32.
		iconAnchor:[16, 32]
	});

	if (!markerOptions) {
		//markerOptions = {draggable:true };
		var markerOptions = {
			position : point,
			map : myMap,
			autoPan : !disableautopan,
			draggable : (edit ? true : false),
			icon : myIcon
		};
	}

	myMarker = L.marker(point, markerOptions)
		.addTo(myMap);

	if (edit) {
		myMap.on("click", function (e) {
			if (e.latlng) {
				document.getElementById('geolat').value=e.latlng.lat;
				document.getElementById('geolon').value=e.latlng.lng;
				document.getElementById('geozoom').value=myMap.getZoom();

				myMarker.setLatLng(e.latlng);
				myMap.panTo(e.latlng);
			}
		});

		myMap.on("zoom", function (e) {
			document.getElementById('geozoom').value=myMap.getZoom();
		});

		myMarker.on("dragend", function (e) {
			var latlng = myMarker.getLatLng();
			document.getElementById('geolat').value=latlng.lat;
			document.getElementById('geolon').value=latlng.lng;

			myMap.panTo(latlng);
		});
	}
	else
	{
		myMap.on("click", function (e) {
			if ("geolocation" in navigator) {
				/* geolocation is available */
				navigator.geolocation.getCurrentPosition(
					function (position) {

						var currentposition = position.coords.latitude + "," + position.coords.longitude;
						jsdirectionsurl = "/directions?engine=fossgit_osrm_car&route=" + currentposition + ";" + jsmapsurl.replace('/#map=19/', '');

						directionsurl = directionsurl.replace(jsmapsurl, jsdirectionsurl);
					},
					function (position) {
						window.open(directionsurl, "map");
					},
				);
			} else {
				window.open(directionsurl, "map");
			}
		});

		myMarker.on("click", function (e) {
			if ("geolocation" in navigator) {
				/* geolocation is available */
				navigator.geolocation.getCurrentPosition(
					function (position) {

						var currentposition = position.coords.latitude + "," + position.coords.longitude;
						jsdirectionsurl = "/directions?engine=fossgit_osrm_car&route=" + currentposition + ";" + jsmapsurl.replace('/#map=19/', '');

						directionsurl = directionsurl.replace(jsmapsurl, jsdirectionsurl);
					},
					function (position) {
						window.open(directionsurl, "map");
					},
				);
			} else {
				window.open(directionsurl, "map");
			}
		});
	}

}

function myEventDetailMapload() {
	if (typeof mapsprovider == "undefined" || mapsprovider == "googlemaps") {
		//myMaploadLeafletGoogle();
		myEventMaploadGoogle();
	} else {
		myEventMaploadLeafletOsm();
		//myMaploadOsmGoogle();
	}
}

function myEventMaploadGoogle(){

	if (!document.getElementById("gmap")) return;

	var myOptions = {
		center: new google.maps.LatLng(globallat,globallong),
		zoom: globalzoom,
		mapTypeId: google.maps.MapTypeId[maptype],
		draggable:false,
		scrollwheel:false
	};
	myMap = new google.maps.Map(document.getElementById("gmap"), myOptions);

	/** Create our "tiny" marker icon */
	var blueIcon = new google.maps.MarkerImage(urlrootloc + mapicon,
		/** This marker is 32 pixels wide by 32 pixels tall. */
		new google.maps.Size(32, 32),
		/** The origin for this image is 0,0 within a sprite */
		new google.maps.Point(0,0),
		/** The anchor for this image is the base of the flagpole at 0,32. */
		new google.maps.Point(16, 32));

	var markerOptions = {
		position:new google.maps.LatLng(globallat,globallong),
		map:myMap,
		icon:blueIcon,
		animation: google.maps.Animation.DROP,
		draggable:false
	};

	myMarker = new google.maps.Marker( markerOptions);

	google.maps.event.addListener(myMarker, "click", function(e) {
		if (detailpopup){
			if (redirecttodirections){
				window.open(locurl);
			}
			else {
				callModalScript();
			}
		}
		else {
			if(maplinknewwindow){
				var mapsWindow = window.open(directionsurl,"_blank");
				mapsWindow.opener = null;
			}
			else{
				document.location = locurl;
			}
		}
	});

	google.maps.event.addListener(myMap, "click", function(e) {
		if (detailpopup){
			if (redirecttodirections){
				var mapsWindow = window.open(locurl);
				mapsWindow.opener = null;
			}
			else {
				callModalScript();
			}
		}
		else {
			if(maplinknewwindow){
				var mapsWindow = window.open(directionsurl,"_blank");
				mapsWindow.opener = null;
			}
			else {
				document.location = locurl;
			}
		}
	});

}

function myEventMaploadLeafletOsm() {
	if (typeof L == 'undefined' || !document.getElementById("gmap")) return;

	var point = new L.LatLng(globallat, globallong);

	var myOptions = {
		center: point,
		zoom: globalzoom,
		zoomControl: true,
		minZoom: 4,
		maxZoom: 18,
		draggable: false,
		scrollwheel:false
	};

	//var myMap = L.map('gmap').setView(point, globalzoom);
	myMap = L.map('gmap', myOptions);

	// create the tile layer with correct attribution
	var osmUrl = 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
	var osmAttrib = 'Map data © <a href="https://openstreetmap.org">OpenStreetMap</a> contributors';
	var osm = new L.TileLayer(osmUrl, {attribution: osmAttrib});

	L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
		attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors',
	}).addTo(myMap);

	var myIcon = L.icon({
		iconUrl: urlrootloc + mapicon,
		iconSize: [32, 32],
		// The anchor for this image is the base of the flagpole at 0,32.
		iconAnchor:[16, 32]
	});

	if (!markerOptions) {
		//markerOptions = {draggable:true };
		var markerOptions = {
			position: point,
			map: myMap,
			autoPan: !disableautopan,
			draggable: false,
			icon: myIcon
		};
	}

	myMarker = L.marker(point, markerOptions)
		.addTo(myMap);

	myMap.on("click", function(e){
			if (detailpopup){
				if (redirecttodirections){
					window.open(locurl);
				}
				else {
					callModalScript();
				}
			}
			else {
				if(maplinknewwindow){
					var mapsWindow = window.open(directionsurl,"_blank");
					mapsWindow.opener = null;
				}
				else{
					document.location = locurl;
				}
			}

	});

	myMarker.on("click", function(e){
		window.open(directionsurl, "map");
	});

}

var myMapMulti = false;
var myMaps = {};

var myMapMultiOptions = {};

function myMaploadMulti(midlat, midlon, minlat, minlon, maxlat, maxlon, maptype, modid) {

	if (typeof mapsprovider == "undefined" || mapsprovider == "googlemaps") {
		myMaploadMultiGoogle(midlat, midlon, minlat, minlon, maxlat, maxlon, maptype, modid);
	}
	else {
		myMaploadMultiOsm(midlat, midlon, minlat, minlon, maxlat, maxlon, maptype, modid);
	}

}

function myMaploadMultiGoogle(midlat, midlon, minlat, minlon, maxlat, maxlon, maptype, modid) {

	var mapid = "gmapMulti" + (modid || '');

	if (!document.getElementById(mapid))
	{
		return;
	}

	myMapMultiOptions = {
		// disable mouse scroll wheel
		//scrollwheel:false,
		zoom: 10,
		mapTypeId: google.maps.MapTypeId[maptype],
		center: new google.maps.LatLng(midlat,midlon)
	}

	var myMap = false;
	if (mapid == "gmapMulti") {
		myMap = myMapMulti = new google.maps.Map(document.getElementById(mapid), myMapMultiOptions);
	}
	else
	{
		myMap = myMaps[modid] = new google.maps.Map(document.getElementById(mapid), myMapMultiOptions);
	}

	var bounds = new google.maps.LatLngBounds(new google.maps.LatLng(minlat,minlon), new google.maps.LatLng(maxlat,maxlon));
	myMap.fitBounds(bounds);

	if (typeof  window['addPointsmyMapMulti' + (modid || '') ] === 'function')
	{
		window['addPointsmyMapMulti' + (modid || '') ]()
	}
	else {
		addPoints();
	}

};

function myMaploadMultiOsm(midlat, midlon, minlat, minlon, maxlat, maxlon, maptype, modid) {

	var mapid = "gmapMulti" + (modid || '');

	if (typeof L == 'undefined' || !document.getElementById(mapid))
	{
		return;
	}

	var point = new L.LatLng(midlat, midlon);

	myMapMultiOptions = {
		center: point,
		zoomControl: true,
		minZoom: 1,
		maxZoom: 18
	};

	var myMap = false;
	if (mapid == "gmapMulti") {
		myMap = myMapMulti = L.map(mapid, myMapMultiOptions);
	}
	else
	{
		myMap = myMaps[modid] = L.map(mapid, myMapMultiOptions);
	}

	// create the tile layer with correct attribution
	var osmUrl = 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
	var osmAttrib = 'Map data © <a href="https://openstreetmap.org">OpenStreetMap</a> contributors';
	var osm = new L.TileLayer(osmUrl, {attribution: osmAttrib});

	L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
		attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors',
	}).addTo(myMap);


	var bounds = L.latLngBounds(L.latLng(minlat,minlon), L.latLng(maxlat,maxlon));
	myMap.fitBounds(bounds);

	if (typeof  window['addPointsmyMapMulti' + (modid || '') ] === 'function')
	{
		window['addPointsmyMapMulti' + (modid || '') ]()
	}
	else {
		addPoints();
	}

};

function addPoint(lat, lon, evtid, locid, loctitle, evttitle, url, icon, count, modid) {

	if (typeof mapsprovider == "undefined" || mapsprovider == "googlemaps") {
		addPointGoogle(lat, lon, evtid, locid, loctitle, evttitle, url, icon, count, modid);
	}
	else {
		addPointOsm(lat, lon, evtid, locid, loctitle, evttitle, url, icon, count, modid);
	}
}

function addPointGoogle(lat, lon, evtid, locid, loctitle, evttitle, url, icon, count, modid) {

	if (typeof modid == 'number')
	{
		myMap = myMaps[modid];
	}
	else {
		myMap = myMapMulti;
	}

	// Create our "tiny" marker icon
	var blueIcon = new google.maps.MarkerImage(
		urlrootloc + icon,
		// This marker is 32 pixels wide by 32 pixels tall.
		new google.maps.Size(32, 32),
		// The origin for this image is 0,0 within a sprite
		new google.maps.Point(0, 0),
		// The anchor for this image is the base of the flagpole at 0,32.
		new google.maps.Point(16, 32));

	// Set up our GMarkerOptions object
	var point = new google.maps.LatLng(lat, lon);
	markerOptions = {
		draggable: false,
		map: myMap,
		icon: blueIcon,
		disableAutoPan:		disableautopan,
		position: point
	};

	var myMarkerMulti = new google.maps.Marker(markerOptions);

	var infowindow;
	if (typeof count != 'undefined') {
		if (count > 0) {
			infowindow = new google.maps.InfoWindow({
				disableAutoPan: disableautopan,
				content: "<div style='color:rgb(134,152,150);font-weight: bold;max-width:250px!important;'>" + loctitle + "<br/><br/><span style='color:#454545;font-weight:normal'>" + count + Joomla.JText._("JEV_MATCHING_EVENTS_CLICK_TO_VIEW") +  "<span></div>"
			});
		} else {
			infowindow = new google.maps.InfoWindow({
				disableAutoPan: disableautopan,
				content: "<div style='color:rgb(134,152,150);font-weight: bold;max-width:250px!important;'>" + evttitle + "<br/><br/><span style='color:#454545;font-weight:normal'>" + loctitle + "<span></div>"
			});
		}
	} else {
		infowindow = new google.maps.InfoWindow({
			disableAutoPan: disableautopan,
			size: new google.maps.Size(150, 50),
			content: "<div style='color:rgb(134,152,150);font-weight: bold;max-width:300px!important;'>" + evttitle + "<br/><div style='color:#454545;font-weight:normal;max-height:200px;overflow:hidden;'>" + loctitle + "</div></div>"
		});
	}
	google.maps.event.addListener(myMarkerMulti, "mouseover", function(e) {
		infowindow.open(myMap,myMarkerMulti);
	});
	google.maps.event.addListener(myMarkerMulti, "mouseout", function(e) {
		infowindow.close(myMap,myMarkerMulti);
	});
	google.maps.event.addListener(myMarkerMulti, "click", function(e) {
		if(maplinknewwindow){
			window.open(url,"_-blank");
		}
		else{
			document.location = url;
		}

	});
}

function addPointOsm(lat, lon, evtid, locid, loctitle, evttitle, url, icon, count, modid){
	if (typeof modid == 'number')
	{
		myMap = myMaps[modid];
	}
	else {
		myMap = myMapMulti;
	}

	var point = new L.LatLng(lat, lon);

	var myIcon = L.icon({
		iconUrl: urlrootloc + icon,
		iconSize: [32, 32],
		// The anchor for this image is the base of the flagpole at 0,32.
		iconAnchor:[16, 32]
	});

	var myIcon = L.icon({
		iconUrl: urlrootloc + icon,
		iconSize: [32, 32],
		// The anchor for this image is the base of the flagpole at 0,32.
		iconAnchor:[16, 32]
	});

	if (!markerOptions) {
		//markerOptions = {draggable:true };
		var markerOptions = {
			position: point,
			map: myMap,
			autoPan: !disableautopan,
			draggable: false,
			icon: myIcon
		};
	}

	var myMarkerMulti = L.marker(point, markerOptions)
		.addTo(myMap);

	myMarkerMulti.bindPopup("<div style='color:rgb(134,152,150);font-weight: bold;max-width:300px!important;'>"+evttitle+"<br/><div style='color:#454545;font-weight:normal;max-height:200px;overflow:hidden;'>"+loctitle+"</div></div>",
		{
			offset:  [0, -16],
		});

	myMarkerMulti.on("mouseover", function(e){
		myMarkerMulti.openPopup();
	});

	myMarkerMulti.on("mouseoout", function(e){
		myMarkerMulti.closePopup();
	});

	myMarkerMulti.on("click", function(e){
		if(maplinknewwindow){
			window.open(url,"_-blank");
		}
		else{
			document.location = url;
		}
	});

}

var myGeocoder = null;

function findAddress(directcall){
	if (typeof mapsprovider == "undefined" || mapsprovider == "googlemaps") {
		myGeocoder = new google.maps.Geocoder();

		findAddressGoogle(directcall);
	}
	else {
		findAddressOsm(directcall);
	}
}

// directcall is true if function is called from clicking a button
function findAddressGoogle(directcall){
	var address = [];
	var searchAddress = '';
	if(document.getElementById("googleaddress"))
	{
		if(document.getElementById("googleaddress").value.length)
		{
			address[0] = document.getElementById("googleaddress").value;
		}
		if(document.getElementById("googlecountry").value.length)
		{
			address[4] = document.getElementById("googlecountry").value;
		}
		if (address.length == 0)
		{
			address = getStreetData(address);

			if(document.getElementById("catid").value != 0)
			{
				address[1] = document.getElementById( "#catid").options[document.getElementById( "#catid").selectedIndex].text;
			}
		}
		if (address.length)
		{
			searchAddress = address.join();
		}
	}
	else {
		try {

			address = getStreetData(address);

			if(document.getElementById("city").value.length)
			{
				address[2] = document.getElementById("city").value;
			}
			if(document.getElementById("state").value.length)
			{
				address[3] = document.getElementById("state").value;
			}
			if(document.getElementById("country").value.length)
			{
				address[4] = document.getElementById("country").value;
			}

			if (address.length)
			{
				searchAddress = address.join();
			}
		}
		catch (e){}
	}

	if (myGeocoder) {
		if(searchAddress.length)
		{
			myGeocoder.geocode( { 'address': searchAddress}, function(results, status) {
				if (status == google.maps.GeocoderStatus.OK) {
					point = results[0].geometry.location;
					myMap.setCenter(point);
					myMarker.setPosition(point);
					document.getElementById('geolat').value=point.lat();
					document.getElementById('geolon').value=point.lng();
					document.getElementById('geozoom').value=myMap.getZoom();
					document.querySelector('.jev_loc_notice').style.display = 'none';
				}
				else {
					document.querySelector('.jev_loc_notice').innerHTML = searchAddress + ', ' + jev_str_notfound;
					document.querySelector('.jev_loc_notice').style.display = 'block';
				}
			});
		}
		// no need to call alert from onblur otherwise we get in a loop
		else if (directcall)
		{
			document.querySelector('.jev_loc_notice').innerHTML = jev_str_introduceaddress;
			document.querySelector('.jev_loc_notice').style.display = 'block';
		}
	}
}

function findAddressOsm(directcall){
	var address = [];
	var searchAddress = '';
	if(document.getElementById('googleaddress'))
	{
		if(document.getElementById("googleaddress").value.length)
		{
			address[0] = document.getElementById("googleaddress").value;
		}
		if(document.getElementById("googlecountry").value.length)
		{
			address[4] = document.getElementById("googlecountry").value;
		}
		if (address.length == 0)
		{
			address = getStreetData(address);

			if(document.getElementById("catid").value != 0)
			{
				address[1] = document.getElementById( "#catid").options[document.getElementById( "#catid").selectedIndex].text;
			}
		}
		if (address.length)
		{
			searchAddress = address.join();
		}
	}
	else {
		try {

			address = getStreetData(address);

			if(document.getElementById("city").value.length)
			{
				address[2] = document.getElementById("city").value;
			}
			if(document.getElementById("state").value.length)
			{
				address[3] = document.getElementById("state").value;
			}
			if(document.getElementById("country").value.length)
			{
				address[4] = document.getElementById("country").value;
			}

			if (address.length)
			{
				searchAddress = address.join();
			}
		}
		catch (e){}
	}

	if(searchAddress.length)
	{
		var url = "//open.mapquestapi.com/nominatim/v1/search.php?key=" + mapquestkey + "&format=json&q=" + encodeURI(searchAddress) + "&addressdetails=1&limit=3";
		const xhr = new XMLHttpRequest();
		xhr.open("GET", url);

		xhr.onload = function () {
			try {
				if (xhr.status != 200) {
					alert('error ' + xhr.statusText);
					return;
				}

				let returnData = JSON.parse(xhr.responseText);
				console.log(returnData);

				if (returnData.length) {
					var point = new L.LatLng(returnData[0].lat, returnData[0].lon);

					myMarker.setLatLng(point);
					myMap.setView(point, globalzoom);

					document.getElementById('geolat').value = point.lat;
					document.getElementById('geolon').value = point.lng;
					document.getElementById('geozoom').value = myMap.getZoom();

					document.querySelector('.jev_loc_notice').style.display = 'none';

				}
				else {
					document.querySelector('.jev_loc_notice').innerHTML = searchAddress + ', ' + jev_str_notfound;
					document.querySelector('.jev_loc_notice').style.display = 'block';
				}

				return;
			} catch (e) {
				alert('bad response = ' + e + "\n" + xhr.responseText );
			}
		}

		xhr.onerror = function () {
			alert('error ' + xhr.statusText);

		}

		xhr.send();

		return;

	}
	// no need to call alert from onblur otherwise we get in a loop
	else if (directcall)
	{
		document.querySelector('.jev_loc_notice').innerHTML = jev_str_introduceaddress;
		document.querySelector('.jev_loc_notice').style.display = 'block';
	}

}

function getStreetData(address)
{

	if(document.getElementById("street").value.length)
	{
		address[0] = document.getElementById("street").value;
	}
	if(document.getElementById("postcode").value.length)
	{
		address[1] = document.getElementById("postcode").value;
	}

	return address;
}
